htimdex - HTML-Image-Directory-Index-Maker
Version 015, 21.05.2001
author: Ilja Kaufmann, Germany, Wuerzburg
contact: kiwi@perelin.de  http://www.perelin.de


contents:

- Copyright
- What the program should do
- What it might do
- installation
- more features
- files and what to do with them (explaining some features)
- using htimdex
- editing/creating html-form-files



Copyright and so on
-------------------
this rexx-programm is freeware. you're allowed to use it
when- and whereever you want to. But everything you do with
it is at YOUR OWN RISK!
You may redistribute htimdex, as long as this readme.t is
included and as long as you don't take ANY sort of charge
for it!
For more details have a look at the GNU-puplic-licence, as
the used ImageMagick is provided under this licence.


what the program should do:
---------------------------
calling ImageMagick, htimdex generates thumbnails and infos for
images, that are stored within a directory-structure.
Then it writes html-files as an index for the image-archiv.
could be used for web-image archives or archives on CD.


what i guarantee the programm to do:
------------------------------------
nothing!
if it formates your harddrive, blows up your monitor or does
something else it's your problem!


what the programm might do:
---------------------------
perhaps it's possible to generate TeX or output in some other
language, because there's no bit of html coded directly into
the program. htimdex takes the given 'html'-files, searches for
certain patterns and replaces them. See below for details.
The received files could contain full pathes instead of
relativ pathes



installation/deinstallation
---------------------------
because you're reading this here, i expect you to have already
unpacked the archiv. if not, so do it now. - into the directory you
want htimdex to be run from.
Then double-click on the install.cmd. two things are done now:
1. the correct home-directory is set within the code of htimdex
   (it is not possible to run htimdex without setting this within the code)
2. a programobject is generated on your wps

if you have ImageMagick already installed on your system,
you can delete the file delegates.zip and go on with the next
point. (also usefull: ghostscript-see below, wmf2png-which could be found
in the delegates.zip)

if there's no running version of ImageMagick on your system,
you have to unpack the delegates.zip archiv and run (by double-
click) the use_own_delegates.cmd.
that should set the working directory for htimdex to the
new delegates-folder and the necessair programms could be found.

if you want to MOVE HTIMDEX, do so, and simply run the install.cmd
  again afterwards, to get the new path known to the program.

to DEINSTALL, delete the programmobjekt and the directory where
  htimdex is located. there are no files placed anywhere else or
  entries made to any ini- or config- file on your system.

for using GERMAN 'UMLAUTE' within the names of your imagefiles under os/2:
  if you really, really want to do so, look for the files
  ind_top.html and dirs_top.html within the html* directories
  uncomment the line
    <meta http-equiv="Content-Type" content="text/html; charset=cp850">
  by removing the <!-- at beginning and --> at the end of the line.
  then your browser will use OS/2's strange codepage 850, but be
  aware, that you may run in problems, with copying your archiv to a
  CD or to a website.
OR: run htimdex with the parameter /uml. than it will check
  the whole given directory structure for umlaute within the file-
  and directory- names and change them like ->oe and so on.

one word concerning PS/EPS/PDF: if you've ghostscript installed
properly, it should be possible for imagemagick to convert these
formats to .gif or others. it's important to have the path of
gsos2.exe in your path-statement in config.sys; also the path
of gsdll2.dll in the libpath and GS_LIB pointing to the gsX.XX/lib
directory. e.g.: SET GS_LIB=d:/gstools/gs6.01/lib


files and what to do with them
------------------------------
(if you are not interested in details you can read on with the next point
 "using htimdex")

htimdex consists of the following files:

htimdex.ico    - icon for the htimdex programmobject
(htimdex.log   - not distributet, a log-file after each run)
htimdex015.cmd - the programm itself
install.cmd    - installroutine for the programm
readme.t       - this readme
(where.ind     - generated after the first run to store which index belongs to which archivdir.
                  never change it!!! )
delegates.zip  - containing the necessair files of ImageMagick and the emx runtime package
(use_own_delegates.cmd - contained in delegates.zip)
(delegates     - directory that is contained in delegates.zip)

html1 up to html5 and html_a up to html_d - example sets of html-forms,
  may contain: dirs_bot.html, dirs_line.html, dirs_top.html, dirs_tree.html
  index.html, ind_bot.html, ind_dirtop.html, ind_tree.html,
  ind_dirbot.html, ind_line.html, ind_top.html, ind_hlf.html
  and htimdex.cfg the config file belonging to each html-set

safe - directory containing used images and user-stuff for the
       html-files. as distributed: left.gif, right.gif
       str0.gif up to str7.gif
       dummy icons for not-image-files, they should be named
       extension.gif where extension is the file extension
       this icon should be used for.
       dummy.gif  - the thumbnail that is used for all the rest.


htimdex needs the following delegate-routines (contained in
delegates.zip):

convert.exe
delegates.mgk
emx.dll
emxlibcm.dll
identify.exe
JPEG.DLL
Magick.dll
mogrify.exe
PNG.DLL
shm.dll
TIFF.DLL
ttf.dll
wmf2png.exe
X11.dll
Xext.dll
Z.DLL

they are part of ImageMagick or its delegates, and of the
emx-runtime package. Refer to the readme-s within the delegates-
directory for more information and copyright notes!


using htimdex
-------------
some possibilities:

1. drop the main folder, containing your image archiv, on the
   htimdex program-object
2. from command line: call htimdex and give
   the root-directory of your image archiv as parameter.
3. very cool: use XWorkplace and put a programmobject for
   htimdex to the configuration folder, then you can start
   it from the context-menu of the folder.

what you get:

within the dropped folder / the used directory, you got an
index.html file - open it with your browser and have fun!
- that's all

up from version 014 there are some possible parameters.
comandlinesyntax:
htimdex [parameter] imagedirectory
or put the parameters to the programmobject
examples for all parameters:

src="html1"     - the html-source to use (directory name,
                  located in the homedir of htimdex)
tnx="60"        - maximum x-size for generated thumbnails
tny="60"        - same for y
tuk="unknown"   - text for unknown file formats (instead of
                  image-format)
idx="$stamm"    - where to create the index ($stamm=imagedirectory)
idx="e:\img_index"     - one more example - then your index
                  will be generated in e:\img_index (must be an existing dir)
ext="all.imgs.zip.t..."  - which files should be displayed
                  within the index (extensionsensitive)
                  additional: all - all files
                              imgs - all identified images
cmp="0"         - when you manage to create different images,
                  with the same name, same size at the same time
                  but in different subdirectories of your archiv,
                  then set this to cmp="1". but i think you won't.
log="4"         - from 0 to 9, this changes the amount of information
                  that will be shown while htimdex is working and
                  is stored within the htimdex.log file
                  (only important for trouble shouting)
                  if you want to see each file processed, set this to
                  at least ="5", but be aware, that in normal cases
                  most running time is spent for writing output to the
                  line, then to generate html-files.
idt="1"         - if set to ="0" htimdex does not try to identify
                  the files as images. it's usefull to save much time
                  when you want to genarate a html-index for a non-image
                  directory structures.
/uml            - use this setting when you want htimdex to change
                  german umlaute within the filenames and directorynames
                  like ->ae  ->ue  ->sz  and so on
                  (but be aware: they are really changed in your filesystem!!!)
/fid            - 'force identify' only usefull when you got a new delegate
                  for imagemagick and you want all files, that are not still 
                  identified as images, to be checked again.

most of these parameters are better to set in the htimdex.cfg
files - especially the thumbnailsize should be related to the html-layout

philosophy: you may change the default htmlsourcedir_name='html1'
within the rexx-code (file htimdex015.cmd line 10) to your
favourite one. if you want to
change sth. for only one certain archiv, use the comandline to invoke
htimdex for this directory with the special settings. from that point
this index will keep it's different settings when you rebuild it
without the parameters.
again: htimdex remembers the parameters for each index generated, 
from the first call for a certain image archiv this archiv got its own
default paramater-set and keep it as long as you don't spezify sth else.


more features
-------------
After changes within the archiv, htimdex could be run again
without doing the whole converting-stuff again. it only
works out the few new images and generate new html-index
files. this for example makes it very fast when changing
the html-basecode.

if your archiv is very big and you want to stop htimdex,
because you need your main cpu time for sth else, do so. next time
you start it for the same directorystructure, it will
remember where it stoped last time and continue there
(concerning the identification of imagas and creation of
thumbnails).

Per default, all thumbnails and html-files are stored within the
directory, htimdex is called for ($stamm), in their own subdirectory-
structure. then, within the generated html-files all pathes are
relativ.
You may change the "html_stamm='$stamm' " entry in the htimdex.cfg
files to every path you want, for example "html_stamm='e:\photoindex' ",
or use the comandlineparameter idx="e:\photoindex".
then the thumbnails and html-files are created within
e:\photoindex\htimdex and the index.html file will appear
in e:\photoindex.
All image-links within the html-files will then get absolut.
Certainly then it's no more possible to move the archiv, but
this method could help to generate indexes on the HD for
existing CDs without copying the CD to the HD first.
(it's possible to move an existing indexdir
 with all thumbnails and the done.ind file to a new location and
 tell htimdex this new location with idx="x:\newlocation")

htimdex remembers every archiv you used it on and where to
store the index. within the index all settings for this
index are stored. if you once change the appearence of
your index by certain parameters this will be remembered
the next time you run htimdex. especially there is a certain
set of html-source-files connected to the archiv and this
one is used again, as long as you don't change it (e.g. by
the comandlineparameter src="other" where other is the
name of the folder the new html source files are located in).

htimdex is also usefull for generating indizes for
non-image-archiv-directories. you can than use the
comandlineparameter idt="0" and htimdex will not try
to call ImageMagick to identify the files as images.
that will save much time. you can put icon-files to
the safe-directory, that should be used with the so
not identified files. their name has to consist of
extension.gif where extension is the fileextension
this icon has to be used for and gif is the desired
icon-format (defined by iconform='gif' in the htimdex.cfg
files) e.g. an 'icon' named zip.gif would be used
for all zip-files.



editing html-source-files
-----------------------------------------

there are provided some examples of html-sources with
htimdex. perhaps i'll create some more...
they are located in the subdirectories
html1, html2 and so on. you're free to create as many of those
subdirectories as you want.
to prescribe the one that should be used by htimdex,
use the parameter src='html3' or similar when calling
htimdex. the default is 'html1' which might be changed
within the htimdex code, look for: htmlsourcedir_name='html1'
(file htimdex015.cmd line 10)


there are two different types of html-sources. they differ
in the parameter onefile='1' or ='0' in the htimdex.cfg file
that belongs to each source-set. 1 means that only one
index-file is generate for the whole directory structure,
you call htimdex for. 0 means, there's one index-file
created for each subdirectory.
the following are examples for the multi-file version:

html1 is an example with a frameset
html2 provides the same with tables
html3 for very large amounts of subdirectories and images
      (without directory structur tree)
html4 for very large amounts of images with dir-tree
html5 files are displayed within a tree-structure

and these are examples for the all-in-one-file version:

html_a one big tree-structure with all dirs and files
html_b dir-tree at the top, tables for each subdir
html_c dir-tree at the top, file overview for each subdir (less info)
html_d subdir overview at top, two-column tables for each subdir

within the directory 'safe' you can place every image or
file, that is needed by your websites. this directory is
created within the target archiv and updated each time
htimdex is run.
per default it comes with a left- and a right-arrow, the
image-files for the directorystructure and
with thumbnails that are used for non-image-files. you
are free to add more of these non-image-file-icons,
they consist of the form fileextension.gif. so for example
an zip.gif is used as icon for all *.zip files within your
"image" archiv.

the html-formular-directory can contain the following files,
that are read and puzzled together by htimdex:

htimdex.cfg - contains info about desired iconsize, where to
              put the result... (have a look into it)
   the line extensions='all' tells htimdex, which archiv files
   should be displayed within the html-pages. you can set
   extensions='all'      - then all files will be displayed
   extensions='imgs'     - only files, recognized as images will be
                           displayes
   extensions='jpg.wmf.pcx'   - only files with these extensions
                                will be displayes. it can be mixed:
   extensions='imgs.t.zip'    - all images and all files with t or zip
                                as extension will be displayed

index.html  - whole html-file that appears in the root
              directory of the imagearchiv
              (could be a frameset or a redirect to the starting file
               in cases of multi-file-indexes. is totaly ignored in
               cases of all-in-one-file indexes)

4 files for building a directory structure overview, that could be
used either as a complete struct.html file (e.g. as part of a frameset)
or could be integrated to the index-files by the 'variable' $fullstruct.

dirs_top.html   - top part of the built directory structure overview
dirs_bot.html   - bottom part of the built directory structure overview
dirs_line.html  - the form that is used for each line of the
                  built directory structure overview - one line per
                  subfolder of your imagearchiv
dirs_tree.html  - little part of each subfolderline, for building the
                  graphic-structur. its repeated according with the
                  depth of each subfolder.

6 files for building the index file(s) itself:

ind_top.html    - top part of the built index-file(s).
ind_bot.html    - bottom part of these/this index-file(s)
ind_dirtop.html - top part for each subdirectory
ind_dirbot.html - the bottom part for each subdirectory
ind_line.html   - the form used for each line of an index file.
                  there will be one line for each file/image within the
                  subdirectory this index-file is generated for.
ind_tree.html   - like dirs_tree, a little part for each line, that is
                  repeated according with the depth of the subfolder the
                  refering file is belonging to - for creating trees with
                  files in it, like html5 or html_a
(ind_hlf.html   - additional 7th file, for splitting the listing of the
                  archivfiles for each subdir in two halfes within the
                  indexfiles. usefull to generate two-coulumn indizes
                  like the example in html_d)

not all of these files have to be used in all cases, e.g. if you don't
want a tree-structure you won't need the *tree.html files. many examples lack
of the ind_dir*.html files, as there's no sub-dir information between the
file information.

Example:
----------
lets say you got an archiv of the following structure:

archivroot      containing files 0A and 0B
  subdir1       containing files 1A and 1B
    subsubdir1  containing files 2A and 2B
  subdir2       containing files 3A and 3B and 3C

what will be put together for the directory structur overview will be:

  dirs_top.html
    dirs_line.html for the archivroot (with 1 times dirs_tree.html if used)
    dirs_line.html for the subdir1 (with 2 times dirs_tree.html if used)
    dirs_line.html for the subsubdir1 (with 3 times dirs_tree.html if used)
    dirs_line.html for the subdir2 (with 2 times dirs_tree.html if used)
  dirs_bot.html

this will be stored for the variable $fullstruct and this will be saved
as the file struct.html to the index directory "htimdex" (as long as
you don't want an all-in-one-file index).
let's see what will be stuck together as THE index.html file when you
want an all-in-one-file index (onefile='1').

  ind_top.html
    ind_dirtop.html for the archivroot (with 1 times ind_tree.html if used)
      ind_line.html for file 0A  (with 1 times ind_tree.html if used)
      ind_line.html for file 0B  (with 1 times ind_tree.html if used)
    ind_dirbot.html for the archivroot
    ind_dirtop.html for the subdir1 (with 2 times ind_tree.html if used)
      ind_line.html for file 1A  (with 2 times ind_tree.html if used)
      ind_line.html for file 1B  (with 2 times ind_tree.html if used)
    ind_dirbot.html for the subdir1
    ind_dirtop.html for the subsubdir1 (with 3 times ind_tree.html if used)
      ind_line.html for file 2A  (with 3 times ind_tree.html if used)
      ind_line.html for file 2B  (with 3 times ind_tree.html if used)
    ind_dirbot.html for the subsubdir1
    ind_dirtop.html for the subdir2 (with 2 times ind_tree.html if used)
      ind_line.html for file 3A  (with 2 times ind_tree.html if used)
      ind_line.html for file 3B  (with 2 times ind_tree.html if used)
      ind_line.html for file 3C  (with 2 times ind_tree.html if used)
    ind_dirbot.html for the subdir2
  ind_bot.html

if you want a file for each subdirectory of the archiv (onefile='0')
you get 4 files: ht0.html for the archivroot, ht1.html for the subdir1,
ht2.html for the subsubdir1 and ht3.html for subdir2. they are
generated as follows:
ht0.html:

  ind_top.html
    ind_dirtop.html for the archivroot (with 1 times ind_tree.html if used)
      ind_line.html for file 0A  (with 1 times ind_tree.html if used)
      ind_line.html for file 0B  (with 1 times ind_tree.html if used)
    ind_dirbot.html for the archivroot
    ind_dirtop.html for the subdir1 (with 2 times ind_tree.html if used)
    ind_dirbot.html for the subdir1
    ind_dirtop.html for the subsubdir1 (with 3 times ind_tree.html if used)
    ind_dirbot.html for the subsubdir1
    ind_dirtop.html for the subdir2 (with 2 times ind_tree.html if used)
    ind_dirbot.html for the subdir2
  ind_bot.html

ht1.html:

  ind_top.html
    ind_dirtop.html for the archivroot (with 1 times ind_tree.html if used)
    ind_dirbot.html for the archivroot
    ind_dirtop.html for the subdir1 (with 2 times ind_tree.html if used)
      ind_line.html for file 1A  (with 2 times ind_tree.html if used)
      ind_line.html for file 1B  (with 2 times ind_tree.html if used)
    ind_dirbot.html for the subdir1
    ind_dirtop.html for the subsubdir1 (with 3 times ind_tree.html if used)
    ind_dirbot.html for the subsubdir1
    ind_dirtop.html for the subdir2 (with 2 times ind_tree.html if used)
    ind_dirbot.html for the subdir2
  ind_bot.html

and so on.
you can see, if you don't use the ind_dir*.html the generated files will
only consist of (example for subdir2 - ht3.html):

  ind_top.html
      ind_line.html for file 3A  (with 2 times ind_tree.html if used)
      ind_line.html for file 3B  (with 2 times ind_tree.html if used)
      ind_line.html for file 3C  (with 2 times ind_tree.html if used)
  ind_bot.html




To get all the infos and filenames and pathes into the generated files,
you can place different "variables" within the html-code. they are
replaced by certain things:

within index.html (multi file indizes)
-----------------

$root       - is replaced by the absolut path of your imagearchivs root directory
$struc      - is replace by the filename (struct.html plus correct relative path)
              of the file containing the directory structure overview generated out of
              dirs_****.html
$first      - the filename of the first index-file which will be the index
              of your image-archives root-directory (ht0.html)
$safe       - name of the safe-folder, where may be placed images that are
              included in the html-sites. (per default $safe will be replaced by safe)
$fullstruct - this will be replaced by the whole struct.html file
              (the directory structure overview, list of subdirs, ...)
              for generating index-files with directory structur
              (building tables instead of framesets like the example
               in html2)
$copyright  - a copyright notice for htimdex
$cdate      - creation date = system date when generating the files
$ctime      - creation time
$i_first    - like $first, but it's not the filename, but only the number
              could be used for side-internal links like <a href="#0">
              it will be replaced by zero and is only there for consistence
$maxdeep    - depth of the deepest subfolder (1=image archiv root dir)
$htmldir    - name of the directory the generated index-files are located in
              per default that's htimdex.
$archivsize - is the sum of the filesize of all files that will be
              DISPLAYED in the generated index.
$amtdirs    - the total number of subdirectories, within the archiv
              (in the above example this would be 3)
$amtfiles   - the total number of files that will be
              DISPLAYED in the generated index.

the resulting file will be named index.html and is located in the
root of the image-archiv, htimdex is called for, or the directory
that is specified with idx="X:\putithere" at the comandline or
html_stamm='X:\putithere' in the htimdex.cfg file.


within dirs_***.html
--------------------

dirs_tree.html:

$nr - is replaced by the number of the graphic-structure-part for the
      tree-graphic. (compare with the strX.gif within the safe folder
      and you will understand - i hope)

dirs_line.html: (one line per subdirectory)

$folder  - name of the actuell subdir, without the relativ path
$dir     - complete relativ path and subdirectory name
$tree    - the graphic-tree generated for this subdir out of dirs_tree.html
$idxfile - filename of the generated index-file for this subdir (htXX.html
            where XX is the number of the file)
$aktdeep - depth of this subdir within the archiv (counted from archivroot==1)
$difdeep - difference maxdeep-aktdeep (could be use for colspan= )
$i_mark  - will only give the XX like in $idxfile, for
           side-internal links like <a href="#$i_mark">$folder</a>
$amtdirfiles - number of displayed files contained by this subdirectory
$totsize - is the sum of the filesize of all files that will be
           displayed in the generated index for this subdirectory.


dirs_top.html and dirs_bot.html and dirs_line.html

$root       - is replaced by the absolut path of your imagearchivs root directory
$struc      - is replace by the filename (struct.html plus correct relative path)
              of the file containing the directory structure overview generated out of
              dirs_****.html - in this case it will be itself
$first      - the filename of the first index-file which will be the index
              of your image-archives root-directory (ht0.html)
$safe       - name of the safe-folder, where may be placed images that are
              included in the html-sites. (per default $safe will be replaced by safe)
$copyright  - a copyright notice for htimdex
$cdate      - creation date = system date when generating the files
$ctime      - creation time
$i_first    - like $first, but it's not the filename, but only the number
              could be used for side-internal links like <a href="#0">
              it will be replaced by zero and is only there for consistence
$maxdeep    - depth of the deepest subfolder (1=root dir)
$htmldir    - name of the directory the generated index-files are located in
              per default that's htimdex.
$archivsize - is the sum of the filesize of all files that will be
              displayed in the generated index.
$amtdirs    - the total number of subdirectories, within the archiv
              (in the above example this would be 3)
$amtfiles   - the total number of files that will be
              displayed in the generated index.

one struct file is generated within the htimdex directory in the image
archiv, per default it's named struct.html


within ind_*.html
-------------------

ind_tree.html:

$nr - is replaced by the number of the graphic-structure-part for the
      tree-graphic. (compare with the strX.gif within the safe folder
      and you will understand - i hope)


ind_line.html: (one line per image)

$tree   - the graphic-tree generated for this line out of ind_tree.html
$ifile  - name of the thumbnail file generated for this image file
$file   - name of the image file with whole relative-path
          (when creating the html-files outside the image archiv,
           $file will provide the absolut path of the image)
$size   - size of the image file in byte
$xsize  - width of the image file
$ysize  - height of the image file
$name   - name of the file without any path information
$ixsize - width of the displayed thumbnail
$iysize - height of the displayed thumbnail
$form   - additinal information to the imagefile - such as format
$date   - last date of writing to this file
$time   - last time of writing to this file


ind_dirtop.html and ind_dirbot.html for each directory

$tree   - the graphic-tree generated for this directory out of ind_tree.html


ind_line, ind_dirtop.html and ind_dirbot.html for each subdirectory
(in the case of multi-file-index like html1 to html5 this is for
all ind_*.html files)

$dir         - name of the image subdirectory, containing the files
               listed in this index file (relativ path)
$folder      - name of the image subdirectory without path
$aktdeep     - depth of this subdir within the archiv (counted from archivroot==1)
$difdeep     - difference maxdeep-aktdeep (could be use for colspan= )
$idxfile     - filename of the generated index file for this subdir (htXX.html
               where XX is the number of the file) here it'l be the actual
               generated file itself.
$next        - name of the next index file like $idxfile but with XX=XX+1
$back        - name of the previous index file like $idxfile but with XX=XX-1
$i_mark      - will only give the XX like in $idxfile, for
               side-internal links like <a href="#XX">subfolderXX</a>
$i_next      - number of the next index file (like $next,
               but only the XX of the name)
$i_back      - number of the last index file (like XX in $back)
$amtdirfiles - number of displayed files contained by this subdirectory
$totsize     - is the sum of the filesize of all files that will be
               displayed in the generated index for this subdirectory.


all ind_*.html files:

$cdate      - creation date (system date)
$ctime      - creation time
$amount     - amount of files within the directory, this index file belongs to
$root       - absolut path of the image archiv
              $root\$folder will give the fullpath of the directory
$struc      - filename of directory structure html file struct.html
$first      - filename of the index file for the root directory
$i_first    - like $first, but it's not the filename, but only the number
              could be used for side-internal links like <a href="#0">
$safe       - name of the safe-folder
$fullstruct - this will be replaced by the whole struct.html file
              (the directory structure overview, list of subdirs, ...)
              for generating index-files with directory structur
              (building tables instead of framesets like the example
               in html2)
$copyright  - a copyright notice for htimdex
$maxdeep    - depth of the deepest subfolder (1=root dir)
$htmldir    - name of the directory the generated index-files are located in
              per default that's htimdex.
$archivsize - is the sum of the filesize of all files that will be
              displayed in the generated index.
$amtdirs    - the total number of subdirectories, within the archiv
              (in the above example this would be 3)
$amtfiles   - the total number of files that will be
              displayed in the generated index.

























